#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<math.h>
#include	<sys/types.h>
#include	<GL/gl.h>
#include	<GL/glu.h>
#include	<GL/glut.h>
#include	"checks.h"

#define checkImageWidth		64
#define checkImageHeight	64

static GLubyte	checkImage[checkImageHeight][checkImageWidth][4];
static GLuint	texName=1;


int main(int argc,char **argv)
{
  /* initialize GLUT, OpenGL */
  glutInit(&argc,argv);

  do_window();
  init();
  bindCheckImage();
  glutDisplayFunc(do_redraw);
  glutReshapeFunc(do_resize);
  glutKeyboardFunc(keyboard);

  /* let it go! */
  glutMainLoop();
}


void init(void)
{
  glClearColor(0.0,0.0,0.0,0.0);
  glShadeModel(GL_FLAT);
  glEnable(GL_DEPTH_TEST);

  setCheckImage('w');
}


void setCheckImage(int color)
{
	int	i,j,c;

  for(i=0;i<checkImageHeight;i++) {
    for(j=0;j<checkImageWidth;j++) {
      c = ((((i&0x8)==0)^((j&0x8))==0))*255;
      checkImage[i][j][0] = checkImage[i][j][1] = checkImage[i][j][2] = 0;
      switch(color) {
        case 'r': checkImage[i][j][0] = (GLubyte)c; break;
        case 'g': checkImage[i][j][1] = (GLubyte)c; break;
        case 'b': checkImage[i][j][2] = (GLubyte)c; break;
        case 'w': checkImage[i][j][0] = checkImage[i][j][1] =
                  checkImage[i][j][2] = (GLubyte)c; break;
      }
      checkImage[i][j][3] = (GLubyte)255;
    }
  }
}


void bindCheckImage(void)
{
	int	textures[1];

  textures[0] = texName;
/*
  glDeleteTexturesEXT(1,(const GLuint *)textures);
*/
  glDeleteTextures(1,(const GLuint *)textures);
  glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
/*
  glBindTextureEXT(GL_TEXTURE_2D,texName);
*/
  glBindTexture(GL_TEXTURE_2D,texName);
  
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
  glTexImage2D(GL_TEXTURE_2D,0,GL_RGBA,checkImageWidth,checkImageHeight,
                             0,GL_RGBA,GL_UNSIGNED_BYTE,checkImage);

}


void do_clear(void)
{
    glDrawBuffer(GL_FRONT);
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
}


void do_window(void)
{
	int	mainmenu,ftypemenu,fontmenu;

  /* set the window pos---let the windowing system determine */
  glutInitWindowPosition(-1,-1);
  /* set the window size */
  glutInitWindowSize(250,250);

  /* set the window display modes (hopefully supported)
     GLUT_DOUBLE: double-buffered
     GLUT_RGBA:   rgba colors (no colormap)
     GLUT_DEPTH:  z-buffering
  */
  glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGBA | GLUT_DEPTH);

  /* create the window */
  glutCreateWindow("test");
}


void do_resize(int w, int h)
{
  glViewport(0,0,(GLsizei)w,(GLsizei)h);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluPerspective(60.0,(GLfloat)w/(GLfloat)h,1.0,30.0);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  glTranslatef(0.0,0.0,-3.6);
}


void do_redraw(void)
{
  /* clear back buffer */
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

  glEnable(GL_TEXTURE_2D);
  glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE, GL_DECAL);
/*
  glBindTextureEXT(GL_TEXTURE_2D,texName);
*/
  glBindTexture(GL_TEXTURE_2D,texName);
  glBegin(GL_QUADS);

  glTexCoord2f(0.0, 0.0);	glVertex3f(-2.0,-1.0,0.0);
  glTexCoord2f(0.0, 1.0);	glVertex3f(-2.0, 1.0,0.0);
  glTexCoord2f(1.0, 1.0);	glVertex3f( 0.0, 1.0,0.0);
  glTexCoord2f(1.0, 0.0);	glVertex3f( 0.0,-1.0,0.0);

  glTexCoord2f(0.0, 0.0);	glVertex3f( 1.0,-1.0,0.0);
  glTexCoord2f(0.0, 1.0);	glVertex3f( 1.0, 1.0,0.0);
  glTexCoord2f(1.0, 1.0);	glVertex3f( 2.41421, 1.0,-1.41421);
  glTexCoord2f(1.0, 0.0);	glVertex3f( 2.41421,-1.0,-1.41421);

  glEnd();
  glFlush();
  glDisable(GL_TEXTURE_2D);

  /* swap buffers */
  glutSwapBuffers();
}


void keyboard(unsigned char key, int x, int y)
{
  switch(key) {
    case 'r':
      fprintf(stdout,"switching to red\n");
      setCheckImage('r');
      bindCheckImage();
      glutPostRedisplay();
      break;
    case 'g':
      fprintf(stdout,"switching to green\n");
      setCheckImage('g');
      bindCheckImage();
      glutPostRedisplay();
      break;
    case 'b':
      fprintf(stdout,"switching to blue\n");
      setCheckImage('b');
      bindCheckImage();
      glutPostRedisplay();
      break;
    case 'w':
      fprintf(stdout,"switching to white\n");
      setCheckImage('w');
      bindCheckImage();
      glutPostRedisplay();
      break;
    case 'q':
    case 27:
      exit(0);
      break;
    default:
      break;
  }
}
